April 20, 2020
Jiaxuan Li
Kim_lijiaxuan@163.com

--Basical description--
This script is tested in Centos operating system, and may be available for other Linux systems.
Its functions are described below.

This main task of our script is to analyze the exonerate output file for extracting identified exons and map these exons onto reference to generate coding sequences. 
In addition, this script can also generate orthologous coding sequence groups used for subsequent phylogenetic analysis.   
In brief, the whole process includes four steps: 
1) Extract information about reference ID, target contig ID, start and end positions of identified exon in target contig, identified exon sequence, length,
   amino acid identity between exon and the reference, score, frame and so on from exonerate output result; 
2) Sort identified exons by their positions in the same reference and filter them by amino acid identity;
3) Map filtered exons to the reference and stitch these discrete exons into a coding sequence;
4) Integrate the coding sequence extraction result of different samples and generate ortholgous coding sequence groups.


--Requirement--
Bioinformatic tools are listed below. We recommend add them into the environmental path to ensure all scripts successfully to be used.

EXONERATE v2.2.0: https://www.ebi.ac.uk/about/vertebrate-genomics/software/exonerate
Python v2.7.9: https://www.python.org/ftp/python/2.7.9


--Usage--
$ python Orthologous_coding_sequence_groups_generation.py -r <filename> -c <contig_dir> -e <exonerate_dir> -o <out_dir> [options]
  -r <filename>      : input reference nucleotide sequences filename in the FASTA format, required
  -c <contig_dir>    : input directory for assembled contigs/scaffolds files, required
  -e <exonerate_dir> : input directory for exonerate output files, required
  -o <out_dir>       : output directory to store all the resulting files, required
  -aI <float>        : amino acid identity (between exon and reference) threshold , default 0.6
  -t <int>           : number of threads, default 1
  -k <int>           : 1 or 0, default 1, by default, intermediate files will be kept
  
  
--Output file description--
The final outputs are reported in your provided output directory, a total of four/five folders are generated:

1) "1.Original_exonerate_analysis_result": All exon information identified by EXONERATE is included in each file (one-sample-per-file).

2) "2.Filtered_exonerate_analysis_result": Sorted and filtered exon information is included in each file (one-sample-per-file). 

3) "3.Sort_sequence_by_sample": Coding sequences extracted from each sample are saved here (one-sample-per-file).

4) "4.Raw_alignments“: All orthologous coding sequence groups are saved here. Each of OG has been already aligned.

5) "temp": All intermediate files are saved here. If you don't need them, you can set '-k 0' to delete them. 
           However, if you're running our script for the first time, I recommend that you keep these files.
		   (don't worry, these temporary files don't take up a lot of memory). 

--Example--
We provide test data for researchers to test our script. 

Linux:
Server@home:~$python ~/PATH/TO/Orthologous_coding_sequence_groups_generation.py -r reference.fasta -c ContigDir -e ExonerateDir -o test -aI 0.60 -t 1 -k 1


